/// <reference types="react" />
import * as React from 'react';
export interface PaginationProps {
    /**
     * 总的记录数目
     */
    total: number;
    /**
     * 每页显示的记录数目
     */
    size: number;
    /**
     * 当前第几页
     */
    current: number;
    /**
     * 指的是从当前页码到显示的最大页码或最小页面的距离
     * 比如，当前页码是3，如果semiBandWidth=5,则lastDigit=8
     */
    semiBandWidth: number;
    /**
     * 当页码改变时触发
     */
    onChange: (page) => any;
}
/**
 * 分页组件
 */
export declare class Pagination extends React.Component<PaginationProps, any> {
    static defaultProps: PaginationProps;
    /**
     * 生成onClick事件处理函数的高阶函数
     */
    _genOnClick(e: any, i: any): (e: any) => boolean;
    _genFirstDigitLink(firstDigit: any): JSX.Element;
    _genLastDigitLink(lastDigit: any): JSX.Element;
    render(): JSX.Element;
}
export default Pagination;
