"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
/**
 * 百度UEditor的React封装
 */
var UEditor = /** @class */ (function (_super) {
    __extends(UEditor, _super);
    function UEditor(props) {
        return _super.call(this, props) || this;
    }
    UEditor.prototype.componentWillMount = function () {
        if (typeof UE != 'undefined' && !!UE.getEditor && !!UE.delEditor) {
            // 如果UE已经是全局变量了，则说明已经加载了UEditor相应的<script>
            return;
        }
        else {
            var scriptConfig = document.querySelector("script[src='" + this.props.uconfigSrc + "']");
            if (!scriptConfig) {
                scriptConfig = document.createElement("script");
                scriptConfig.src = this.props.uconfigSrc;
                document.body.appendChild(scriptConfig);
            }
            var scriptEditor = document.querySelector("script[src='" + this.props.ueditorSrc + "']");
            if (!scriptEditor) {
                scriptEditor = document.createElement("script");
                scriptEditor.src = this.props.ueditorSrc;
                document.body.appendChild(scriptEditor);
            }
        }
    };
    UEditor.prototype.componentDidMount = function () {
        function waitUntil(props) {
            try {
                var ue_1 = UE.getEditor(props.id, {
                    initialFrameWidth: props.width,
                    initialFrameHeight: props.height,
                });
                ue_1.setDisabled();
                ue_1.ready(function () {
                    ue_1.setContent(props.initialValue);
                    ue_1.setEnabled();
                    props.afterInit(ue_1);
                });
            }
            catch (err) {
                console.log('暂时无UE对象可用，等待50ms', err);
                setTimeout(function () { waitUntil(props); }, 50);
            }
        }
        waitUntil(this.props);
    };
    UEditor.prototype.componentWillUnmount = function () {
        UE.delEditor(this.props.id);
        // 不再卸载<script> :
        //     <script type="text/javascript" src="/static/ueditor/ueditor.config.js"></script>
        //     <script type="text/javascript" src="/static/ueditor/ueditor.all.min.js"></script>
    };
    UEditor.prototype.render = function () {
        return (React.createElement("script", { id: this.props.id, type: "text/plain" }));
    };
    UEditor.defaultProps = {
        id: 'ueditorcontainer',
        height: 600,
        width: 600,
        initialValue: '',
        afterInit: function (ue) { },
        uconfigSrc: "/static/ueditor/ueditor.config.js",
        ueditorSrc: "/static/ueditor/ueditor.all.min.js",
    };
    return UEditor;
}(React.Component));
exports.UEditor = UEditor;
exports.default = UEditor;
//# sourceMappingURL=index.js.map